package leerTXTaInterfaz;

import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;

import javax.swing.*;
import javax.swing.border.BevelBorder;

public class LectorSwing extends JFrame{
	
	private JButton btElegir;
	private JButton btLeer;
	private JTextField jtRuta;
	private JTextArea areaTexto;
	
	//Constructor del JFrame
	public LectorSwing() {
		
		iniciarComponentes();
		
		//Panel superior con campo de texto y botones
		JPanel pnNorte = new JPanel();
		pnNorte.setLayout(new BoxLayout(pnNorte, BoxLayout.Y_AXIS));
		JPanel pnElegir = new JPanel();
		pnElegir.add(new JLabel("Indique ruta del fichero: "));
		pnElegir.add(jtRuta);
		pnElegir.add(btElegir);
		JPanel pnLeer = new JPanel();
		pnLeer.add(btLeer);
		pnNorte.add(pnElegir);
		pnNorte.add(new JSeparator(SwingConstants.HORIZONTAL));
		pnNorte.add(pnLeer);
		pnNorte.setBorder(BorderFactory.createCompoundBorder(
				BorderFactory.createEmptyBorder(15, 15, 15, 15),
				BorderFactory.createRaisedSoftBevelBorder()));
		
		//Panel central con el area de texto
		JPanel pnCentro = new JPanel();
		JScrollPane sp = new JScrollPane(areaTexto); //Proporciona al area de texto barras de scroll
		sp.setBorder(BorderFactory.createBevelBorder(BevelBorder.RAISED));
		pnCentro.add(sp);
		
		//Configuracion del JFrame
		setLayout(new BorderLayout());
		add(pnNorte, BorderLayout.NORTH);
		add(pnCentro, BorderLayout.CENTER);
		
		setTitle("Lector TXT");
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		pack();
		setLocationRelativeTo(null);
		setVisible(true);
	}
	
	private void iniciarComponentes() {
		btElegir = new JButton("Seleccionar");
		btElegir.addActionListener(new AccionElegirFichero());
		btLeer = new JButton("Leer TXT");
		btLeer.addActionListener(new AccionLeerTXT());
		jtRuta = new JTextField(15);
		jtRuta.setToolTipText("Ruta del archivo a leer");
		areaTexto = new JTextArea(15, 40);
		areaTexto.setEditable(false);
	}

	//Método main para poner en marcha el programa
	public static void main(String[] args) {
		SwingUtilities.invokeLater(new Runnable() {
			@Override
			public void run() {
				new LectorSwing();	
			}
		});
	}
	
	private class AccionElegirFichero implements ActionListener {
		@Override
		public void actionPerformed(ActionEvent e) {
			//Abrimos ventana para seleccionar fichero
			JFileChooser selector = new JFileChooser();
			selector.showOpenDialog(null);
			String ruta = selector.getSelectedFile().getAbsolutePath();
			jtRuta.setText(ruta); //Mostramos la ruta del archivo escogido
		}
	}
	
	private class AccionLeerTXT implements ActionListener {
		@Override
		public void actionPerformed(ActionEvent e) {
			
			
			String ruta = jtRuta.getText(); //Recogemos ruta de fichero escogido
			//Comprobamos que no esté en blanco
			if (ruta.isBlank())
				JOptionPane.showMessageDialog(null, "Escoja una ruta", "Leer TXT",
						JOptionPane.WARNING_MESSAGE);
			else {
				//La clase LectorTXT nos proprocionará un ArrayList con el texto leido
				ArrayList<String> texto = LectorTXT.leerTXT(ruta);
				if (texto == null)
					JOptionPane.showMessageDialog(null, "No se pudo leer el fichero escogido", "Leer TXT",
							JOptionPane.ERROR_MESSAGE);
				else {
					//Transferimos las lineas leidas, al area de texto
					for (String linea: texto)
						areaTexto.append(linea + "\n");
				}
			}
		}
	}

}
